VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1470
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3330
   LinkTopic       =   "Form1"
   ScaleHeight     =   1470
   ScaleWidth      =   3330
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton btnGo 
      Caption         =   "Start demonstration !"
      Default         =   -1  'True
      Height          =   615
      Left            =   450
      TabIndex        =   0
      Top             =   240
      Width           =   2280
   End
   Begin VB.Label Label 
      Caption         =   "Results in debug window !"
      Height          =   375
      Left            =   630
      TabIndex        =   1
      Top             =   960
      Width           =   1995
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'
'   Simple demonstration.
'


Option Explicit

Private WithEvents RS   As clsRecordset     ' a class only to read/write a little bit ... ;)
Attribute RS.VB_VarHelpID = -1

Private DB              As Database
'
'
'

Private Sub Form_Load()

    Set DB = DBEngine.Workspaces(0).OpenDatabase("clsRS_demo_db.mdb")

    Set RS = New clsRecordset

    RS.SetDefaults DB, "ConfigValues", "PropertyKey", "PropertyValue", , RS_KEEP_OPEN, _
            RS_ADD_KEY_IF_NECCESSARY, RS_RAISE_SUCCESS_EVENT

End Sub


Private Sub btnGo_Click()
  
    On Error GoTo ERR_btnGo_Click

    With RS
        
        Debug.Print "Key 'Height' = " + .Value("Height")
        
        Debug.Print "Key 'Name' = " + .Value("Name")
                
        .Value("Width") = "2000"
        
        .Value("Server 001", , , , "LastAccess", "Computer", "LastAccess") = Now
        .Value("Server 001", RS_DONT_KEEP_OPEN, , , , , "IPadress") = "192.10.150.12"
        
        .RaiseSuccessEvent = RS_DONT_RAISE_SUCCESS_EVENT
        
        Debug.Print "Key 'Server 001' Last access = " + _
                Format(.Value("Server 001", , , , , , "LastAccess"), "ddd mmm yyyy  -  hh:nn")
        
        
        DB.Execute "DELETE * FROM LastAccess WHERE Computer = 'Workstation 007'"    ' Rerunning demo ? Clean up!
        
        .RaiseSuccessEvent = RS_RAISE_SUCCESS_EVENT
        
        .Value("Workstation 007", , RS_ADD_KEY_IF_NECCESSARY) = Now
        
        .CloseConnection
        
    End With

   On Error GoTo 0
   Exit Sub


ERR_btnGo_Click:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure btnGo_Click() of Formular Form1"
    
End Sub


Private Sub RS_ErrorRS(ByVal ErrorType As enErrorType, ByVal sErrorDesc As String, ByVal flgFatal As Boolean)
    
    If flgFatal = True Then
        MsgBox "Attention ! A fatal error occured !" + vbCrLf + vbCrLf + sErrorDesc, vbCritical, _
                "Error in recordset class"
    End If
    
    Debug.Print "->>  [Msg from event handler:  " + sErrorDesc + "]"

    Select Case ErrorType

        Case RS_ET_SUCCESS_NO_ERROR

        Case RS_ET_DATABASE_NOT_SET

        Case RS_ET_TABLE_NOT_SET

        Case RS_ET_KEY_COLUMN_NOT_SET

        Case RS_ET_VALUE_COLUMN_NOT_SET

        Case RS_ET_ERROR_OPENING_RS

        Case RS_ET_KEY_NOT_FOUND

        Case RS_ET_WRITE_ERROR

        Case RS_ET_READ_ERROR

    End Select

End Sub


Private Sub Form_Unload(Cancel As Integer)

    Set RS = Nothing
    Set DB = Nothing
    
End Sub

' #*#
